﻿#ifndef CMDCONFIG_H
#define CMDCONFIG_H

//点击触发型参数枚举(绣花机超级用户参数、冲缝绣产线软件设置参数、网络管理参数)
enum CLICK_ALL_FUNCTION {
                         ROOT_HMICONFIGURATION = 0,      //界面配置
                         ROOT_MACHINEPARA,     // 机器参数
                         ROOT_WORKPARA,              // 工作参数
                         ROOT_TRAVERSESET ,         // 遍历设置
                         ROOT_HEADBOARDBUSDETECT,  //机头板总线检测
                         ROOT_AUTOSETSOFTLIMIT,  // 自动定软限位
                         ROOT_EMBHEADPARAMETER,            // 平绣机头板参数
                         ROOT_TOWELHEADPARAMETER,            // 毛巾机头板参数
                         ROOT_COILHEADPARAMETER,            // 缠绕机头板参数
                         ROOT_HCPSPARAMETER,            // 换色板参数
                         ROOT_TOWELHCPSPARAMETER,            // 毛巾色板参数
                         ROOT_PATTERNPARAMETERS,              //花样参数
                         ROOT_EMBLOCKTEST ,         // 平绣锁头测试
                         ROOT_EMBHOOKTEST ,        // 平绣勾刀测试
                         ROOT_HEADUPDATE,            // 平绣机头板升级
                         ROOT_TOWELHEADUPDATE,            // 毛巾机头板升级
                         ROOT_COILHEADUPDATE,            // 缠绕机头板升级
                         ROOT_HCPSUPDATE,            // 换色板升级
                         ROOT_CLEARPATTERN,              //花样总清
                         ROOT_VERSIONRECOVERY,       //版本恢复
                         ROOT_DEBUGMODE,            //界面进入调试模式
                         ROOT_RESOLUTION,           //分辨率
                         ROOT_MACTYPE,              //机器类型
                         ROOT_PRODUCTTYPE,          //产品类型
                         ROOT_COMBINEEMB,           //双头组合绣
                         ROOT_THREECOMBINEEMB,           //三头组合绣
                         ROOT_HEADEMB,                 //隔头绣
                         ROOT_LASER,                      //激光
                         ROOT_SHUTTLECHANGE,                      //自动换梭
                         ROOT_TRACKROPEEMB,     //跟踪绳绣
                         ROOT_STEPPERDRIVE,//步进驱动
                         ROOT_CAMCOLORCHANGE,//凸轮换色
                         ROOT_BEAD,                       //散珠
                         ROOT_SEQUIN,                 //亮片
                         ROOT_TOWEL,                  //毛巾
                         ROOT_COIL,                  //缠绕
                         ROOT_SIMPLETOWEL,         //简易毛巾
                         ROOT_INDEFOOT, //独立压脚
                         ROOT_WATERMARKSET,          //主背景水印设置(是否带水印)
                         ROOT_WIFI,          //是否带Wifi
                         ROOT_GRADIENT,          // 3D显示
                         ROOT_PARASORTSET,          //参数分类设置(是否分类)
                         ROOT_FILESENDMODE,//文件发送模式
                         ROOT_HMIDECRYPT,            // 界面解密
                         ROOT_CHANGEPASSWORD,    //修改一级密码
                         ROOT_IOTCONFIGURATION,   //物联网配置-物联网配置
                         ROOT_GATEWAYCONNECTIONMETHOD, //物联网配置-网关连接方式
                         ROOT_RACKNUMBERINPUT,  //物联网配置-机架号输入
                         ROOT_NETWORKSETTINGS,   //物联网配置-网络设置
                         ROOT_DELIVERYTIME,   //物联网配置-工厂预计交货时间
                        ROOT_DEBUGPROGRESS,   //物联网配置-调试进度
                        ROOT_DELETEINI,    //删除配置文件
                        ROOT_IMPORTCSV ,   //导入CSV文件
                        ROOT_DELETECSV ,   //删除CSV文件
                        ROOT_RESETCSV ,   //重置安装调试进度
                        ROOT_FRAMEANGLESETTING,    //动框角度设置
                        ROOT_EMBSPINDlLEGEARRATIO,//平绣主轴齿轮比测试
                        ROOT_TOWELSPINDlLEGEARRATIO,//毛巾主轴齿轮比测试
                        ROOT_FLAT_ECD_WIDTH,			// 测试平绣主轴编码器宽度
                        ROOT_FOOTTEST,//独立压脚测试
                         ROOT_EMBWORKAREA ,//平绣设置可工作区域
                         ROOT_CHENWORKAREA, //毛巾设置可工作区域
                         ROOT_COILWORKAREA, //缠绕设置可工作区域
                         ROOT_FRAMEIMPORTPARA, //动框参数导入
                         ROOT_FRAMEEXPORTPARA, //动框参数导出
                         ROOT_CLEARPATTERNFCG, //删除花样fcg文件
                         ROOT_CLEARPATTERNFCG_FILEID, //清除花样fcg文件影响fileid的数据
                         PSE_SOFTWAREPARA_IMPORTPARA,      // 参数导入
                         PSE_SOFTWAREPARA_EXPORTPARA,      // 参数导出
                         PSE_SOFTWAREPARA_HMIUPDATE,        // 界面升级
                         PSE_SOFTWAREPARA_MCUPDATE,         // 主控升级
                         PSE_SOFTWAREPARA_EXIT ,         // 退出程序
                         //毛巾调试参数
                         ROOT_LIFTMOTORCONTROL,//提升电机控制
                         ROOT_ELASTICCONTROL ,//松紧线控制（毛巾）
                        ROOT_CHENILLECOLORDEBUG// 毛巾换色调试
                   };

//组合动作功能类型(罩杯口罩机中有用，其他暂未使用)
enum COMBINE_TYPE { TYPE1 = 1, TYPE2, TYPE3,TYPE4,TYPE5,TYPE6,TYPE7,
                TYPE8,TYPE9,TYPE10,TYPE11,TYPE12,TYPE13,TYPE14,TYPE15,
                TYPE16,TYPE17,TYPE18,TYPE19,TYPE20,TYPE21,TYPE22,
                  TYPE23,TYPE24,TYPE25,TYPE26,TYPE27};

enum MC_TYPE { NUM1 = 1, NUM2, NUM3, NUM4, NUM5, NUM6, NUM7, NUM8, NUM9 };//板卡号

enum COMBINE_FUN
{
                 COMBINE_RUN = 1, //组合动作
                 COMBINE_NULL
 };

//产线主界面功能的枚举
enum MAIN_FUNCTION {
                MAIN_SENSOR = 1,        // 传感器信号
                MAIN_PARASET,             // 参数设置
                MAIN_OUTCONTROL,      // 控制动作
                MAIN_COMBINEACTION, // 组合动作
                MAIN_BOTTOMLINECOUNTRESET,  // 底线计数复位
                MAIN_COUNTCLEAR ,  // 计数清零
                MAIN_REASTALL ,//整机全部复位
                MAIN_MANUALSWITCH,  // 手动切换
                MAIN_AUTOSWITCH  // 自动切换
};


//此头文件定义了常用功能的枚举
enum SHORTCUT_FUNCTION {
                            //平绣机
                            FUN_ALLTOZERO = 1,     // 全部归零
                            FUN_FLATEMBHOOK,       // 平绣勾线
                            FUN_SPINDLEJOG,        // 主轴点动
                            FUN_SPINDLEROTATE,        // 主轴旋转
                            FUN_BACKWORKPOINT,     // 回工作点
                            FUN_BACKTOORIGIN,      // 回原点
                            FUN_SETOFFSETPOINT,    // 定偏移点
                            FUN_BACKOFFSETPOINT,   // 回偏移点
                            FUN_SETSTARTEMBPOINT,  // 定起绣点(绣花机)
                            FUN_BACKSTARTEMBPOINT, // 回起绣点(绣花机)
                            FUN_SETANCHORPOINT,  // 定定位点
                            FUN_BACKANCHORPOINT, // 回定位点
                            FUN_CHECKFRAME,        // 边框检查
                            FUN_FORWARDORBACK,     // 前进回退
                            FUN_QUANTITYMOVEFRAME,      // 定量移框
                            FUN_NEEDLERODPOSITION,  //针杆定位
                            FUN_SIMULATEFRAME,    //空走边框
                            FUN_TOWELCABLE,//毛巾拉线
                            FUN_PROCESSRESET,    //流程复位
                            FUN_SETFEEDINGPOINT,    //定上料点
                            FUN_BACKFEEDINGPOINT,    //回上料点
                            FUN_MANUALOIL,    //手动加油
                            FUN_PATTERNSELECT,    // 花样选择
                            FUN_SHUTTLECOUNT,//梭盘计数复位
                            FUN_EMBWORKAREA,//平绣设置可工作区域
                            FUN_RESETREPEATNUM,//重置反复次数

                            //亮片
                            FUN_LEFTSEQUINCHANGECOLOR, // 左亮片换色
                            FUN_RIGHTSEQUINCHANGECOLOR, // 右亮片换色
                            //毛巾和平绣都有的功能
                            FUN_MANUALTRIM,        // 手动（平绣，毛巾）剪线
                            FUN_CUTOPENANDCLOSE,   // 剪刀（平绣，毛巾）开合
                            FUN_SWITCHHEAD,        //机头（平绣，毛巾）切换
                            FUN_MANUALCHANGECOLOR, // 手动（平绣，毛巾）换色
                            FUN_TOWELCHANGECOLOR, // 毛巾换色    //只有毛巾的时候会用到
                            FUN_CHENWORKAREA,// 毛巾设置可工作区域
                             //缠绕
                            FUN_THREAD,		// 缠绕剪线,主轴动作,剪线
                            FUN_ONOFF,	// 缠绕剪刀开合,只剪刀开合动作,也叫做下剪线
                            FUN_SPINDLE_TO_ANGLE,	// 缠绕主轴去指定角度
                            FUN_COIL_MS_JOG,					// 缠绕点动
                            FUN_COILWORKAREA,// 缠绕设置可工作区域

                            FUN_MS_ROTATE,  //M轴旋转

                            FUN_PRODUCTSTATIS,  //生产统计

                            FUN_NULL = 10000   // 无功能   无功能应该放在最后一位,因为常用功能得最大值就是无功能,否则无法一一对应
                            };

//辅助功能的枚举
enum ASSIST_FUNCTION {
                         ASSIST_SENSOR = 1,     // 传感器信号
                         ASSIST_CONTROLACTION,       // 控制动作
                         ASSIST_HMIUPGRADE,        // 界面升级
                         ASSIST_MCUPGRADE,        // 主控升级
                         ASSIST_EXBUPGRADE,     // 外围板升级
                         ASSIST_PARAIMPORT,      // 参数导入
                         ASSIST_PARAEXPORT,    // 参数导出
                         ASSIST_SOFTWARESET,   // 软件设置
                         ASSIST_AUTHORIZATION,  // 软件授权
                         ASSIST_NETWORK, // 网络管理
                         ASSIST_WIFI, // WIFI管理
                         ASSIST_NEEDLESET,        // 针杆设置
                         ASSIST_TIMESET,        // 时间设置
                         ASSIST_SHORTCUTSET,   // 常用设置
                         ASSIST_PRODUCTSTATICS, // 生产统计
                         ASSIST_LOGFILE,//文件日志
                        ASSIST_ERRORLOG,//错误日志
                        ASSIST_BREAKAGELOG,//断线日志
                         ASSIST_MCVERSION,     // 版本信息
                         ASSIST_EXBVERSION,      // 外围板信息
                         ASSIST_BOTTOMLINEDETECT,  //底线检测（平绣）
                         ASSIST_FACELINEDETECT,    //面线检测（平绣）
                         ASSIST_COILBOTTOMLINEDETECT,  //底线检测（缠绕）
                          ASSIST_COILFACELINEDETECT,    //面线检测（缠绕）
                         ASSIST_SPINDLETEST,    //主轴研车
                         ASSIST_SEQUINDEBUG ,//亮片调试
                         ASSIST_TOWELDEBUG,//毛巾调试
                         ASSIST_MSPINDLE_TO_ANGLE,//缠绕M轴去指定角度
                         ASSIST_CHANGEASHUTTLE ,// 自动换一个梭
                         ASSIST_AGINGTEST,//老化测试（内缝被界面）
                         ASSIST_ROOT,    //超级用户
                         ASSIST_SHUTDOWN,    //关机
						 ASSIST_WKPARAIMPORT,      // 工作参数导入
                         ASSIST_BOTTOMLINECOUNTRESET, // 底线计数复位
                         ASSIST_DEBUGINFO,//调试信息
                         ASSIST_NULL   // 无功能
                       };

//花样设置功能的枚举
enum PATTERNSET_FUNCTION {
                         PATTERNSET_PATTERNSELECT = 1,     // 花样选择
                         PATTERNSET_PATTERNPARA,       // 花样参数
                         PATTERNSET_PATTERNCOLOR,        // 花样色序
                         PATTERNSET_TOWELHEIGHT,        // 毛巾高度
                         PATTERNSET_PATTERNIMPORT,        // 花样导入
                         PATTERNSET_PATTERNEXPORT,     // 花样导出
                         PATTERNSET_PATTERNDELETE,     // 花样删除
                         PATTERNSET_NULL   // 无功能
                       };

//参数设置参数类型的枚举
enum PARASET_FUNCTION {
                         PARASET_POSITION = 1,     // 位置参数
                         PARASET_SPEED,                // 速度参数
                         PARASET_ACTION,              // 动作参数
                         PARASET_DETECT,               // 检测参数
                         PARASET_SETTING ,             // 设置参数
                         PARASET_EMB ,             // 绣花参数
                         PARASET_CHEN,            // 毛巾参数
                         PARASET_FEED,            // 上下料参数
                         PARASET_SHUTTLE ,      //自动换梭参数
                        PARASET_LASER,         //激光参数
                        PARASET_CUT,         //剪线参数
                        PARASET_COIL ,     //缠绕参数
                        PARASET_SQU,    //亮片参数
                        PARASET_BEAD ,     //散珠参数
                        PARASET_SIMPLETOWEL,     //简易毛巾参数
                        PARASET_TRACKROPR//跟踪绳绣参数
                     };

//刺绣功能的枚举
enum EMBFUN_FUNCTION {
                         EMBFUN_BORDEREMB = 1,   // 边框刺绣
                        EMBFUN_MATEEMB,             // 匹绣
                        EMBFUN_HEADEMB,             // 隔头绣
                        EMBFUN_PATCHEMB,            // 贴布绣
                        EMBFUN_OPENLINEEMB,       // 开位线绣
                        EMBFUN_OUTLINE,               // 花样轮廓
                        EMBFUN_OUTLINECHECK,      //轮廓刺绣
                        EMBFUN_LINEOFFSET,                // 线迹偏移
                        EMBFUN_REPEATED,                // 反复绣
                        EMBFUN_WORKSUSPENSION,                // 工作暂停(绗绣机)
                        EMBFUN_NULL                     // 无功能
                       };

enum OUTCONTROL_FUN {
                OUTCONTROL_ENABLE = 1, // 使能
                OUTCONTROL_DISABLE,    // 失能
                OUTCONTROL_MS_ENABLE,  // 平绣主轴电机使能
                OUTCONTROL_MS_DISABLE, // 平绣主轴电机失能
                OUTCONTROL_TOWEL_ENABLE,  // 毛巾主轴电机使能
                OUTCONTROL_TOWEL_DISABLE, // 毛巾主轴电机失能
                OUTCONTROL_TOWELM_ENABLE,  // 毛巾M主轴电机使能
                OUTCONTROL_TOWELM_DISABLE, // 毛巾M主轴电机失能
                OUTCONTROL_TOWELRM_ENABLE,  // 毛巾打环轴电机使能
                OUTCONTROL_TOWELRM_DISABLE, // 毛巾打环轴电机失能    
                OUTCONTROL_COIL_ENABLE,  // 缠绕主轴电机使能
                OUTCONTROL_COIL_DISABLE, // 缠绕主轴电机失能
                OUTCONTROL_COILM_ENABLE,  // 缠绕M主轴电机使能
                OUTCONTROL_COILM_DISABLE, // 缠绕M主轴电机失能
                OUTCONTROL_JOGP,       // 正转
                OUTCONTROL_JOGN,       // 反转
                OUTCONTROL_STOP,       // 停止
                OUTCONTROL_ZERO,       // 归零
                OUTCONTROL_LEFT,       // 左位
                OUTCONTROL_MIDDLE,     // 中位
                OUTCONTROL_RIGHT,      // 右位
                OUTCONTROL_UP,         // 上升
                OUTCONTROL_DOWN,       // 下降
                MANUALACTION_RUN,        // 执行
                OUTCONTROL_OPEN,       // 打开
                OUTCONTROL_CLOSE,       // 关闭
                OUTCONTROL_STARTOIL,       // 开始
                OUTCONTROL_STOPOIL,       // 停止
                OUTCONTROL_FOLLOWPOS,    // 缠绕压脚跟随位
                OUTCONTROL_TOUP,            // 缠绕锯齿上位
                OUTCONTROL_CTRL1 ,      //缠绕锯齿摆动位1
                OUTCONTROL_CTRL2,       //缠绕锯齿摆动位2
                OUTCONTROL_ZEROPOS   //缠绕锯齿零位
              };

//软件设置的顺序枚举
enum ENUM_SOFTWARESET {
                         SET_THEME = 0,             // 主题
                         SET_LANGUAGE = 0,          // 语言
                         SET_FONTSIZE,            //字体大小
                         SET_CONNECTMODE,   //连接方式(通讯方式)
                         SET_TITLEBAR           //设置标题栏
                                                //参数设置界面参数显示方式
                       };

//花样参数的顺序枚举
enum ENUM_PATTERNPARA {
                         SET_ROTATESTYLE = 0,    // 旋转式样
                         SET_HORIZONTALSTYLE,    // 水平翻转样式
                         SET_VERTICALSTYLE,      // 垂直翻转样式
                         SET_ROTATEANGLE,        // 旋转角度
                         SET_XZOOM,              // X向倍率
                         SET_YZOOM,              // Y向倍率
                         SET_REPEATSTYLE,        // 反复方式
                         SET_PRIORITY,           // 优先次序
                         SET_XREPEATNUM,         // X向反复次数
                         SET_YREPEATNUM,         // Y向反复次数
                         SET_XREPEATSPACE,       // X向反复间距
                         SET_YREPEATSPACE,       // Y向反复间距
                         SET_LOCKNEEDLESNUM,    // 锁针次数
                         SET_LOCKNEEDLESSTEPNUM,       // 锁针步数
                         SET_LOCKNEEDLESSTEPLENTH,       // 锁针针步长度
                         SET_JUMPNEEDLECHANGE,       // 跳针变越框锁针针数
                         SET_CHANGLOOKNEEDLE,       // 换色锁针针数
                         SET_XCOMPENSATE,        // X向补偿
                         SET_YCOMPENSATE,         // Y向补偿
                         SET_MINSTEP,         // 过滤针步长度
                         SET_STEPCOMPENSATE,     // 针步补偿
                         SET_CONVERTJUMPSTEPSIZE,     // 绣花机中需要插入跳针的针步大小
                        SET_JUMPSTEPSIZE,     // 绣花机中插入跳针的针步大小
                        SET_OFFSETPOINTXENFLAG ,       // 偏移点X向允许
                        SET_OFFSETPOINTYENFLAG ,       // 偏移点Y向允许
                        SET_OFFSETPOINTX ,       // 偏移点X
                        SET_OFFSETPOINTY ,       // 偏移点Y
                        SET_MC_REPETITIONPARA1,//反复启动方式
                        SET_MC_REPETITIONPARA2,//反复绣起绣点是否暂停
                        SET_MC_XREPEATNUM,         // X向反复次数
                        SET_MC_XREPEATSPACE,       // X向反复间距
                        SET_MC_YREPEATNUM,         // Y向反复次数
                        SET_MC_YREPEATSPACE,       // Y向反复间距
                        SET_MC_PRIORITY,          // 优先次序
                        SET_BEADSEQUIN, //珠片基索引
                        SET_PLEATEDMODE //是否为褶绣模式
                       };

//花样轮廓参数的顺序枚举
enum ENUM_PATTERNOUTLINEPARA {
                                SET_OUTLINESTEP = 0,    // 轮廓针步
                                SET_OUTLINEZOOM,        // 轮廓放大
                                SET_OUTLINESHAPE        // 轮廓形状(凹形、凸形)
                             };

//网络管理设置的顺序枚举
enum ENUM_NETWORKSET {
                         SET_MQTT_SERVERIP = 0,      // 网关服务器IP
                         SET_MQTT_SERVERPORT,        // 网关服务器端口
                         SET_MACHINE_SERVERIP,      // 机器服务器IP
                         SET_MACHINE_SERVERPORT,        // 机器服务器端口
                         SET_LOCALIP,           // 本地IP
                         SET_LOCALPORT         // 本地端口
                       };

#endif // CMDCONFIG_H
